package com.search.supersearch;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.json.JSONUtil;
import com.google.common.collect.Lists;
import com.search.supersearch.controller.DocsController;
import com.search.supersearch.demo.EmployeeElasticController;
import com.search.supersearch.demo.EmployeeInfo;
import com.search.supersearch.dto.DocsDTO;
import com.search.supersearch.dto.DocsDTO2;
import com.search.supersearch.dto.SearchDTO;
import com.search.supersearch.repository.DocsRepository;
import com.search.supersearch.vo.SearchVO;
import lombok.SneakyThrows;
import org.apache.tika.Tika;
import org.apache.tika.parser.ParseContext;
import org.apache.tika.parser.txt.TXTParser;
import org.junit.jupiter.api.Test;
import org.springblade.core.tool.api.R;
import org.springframework.beans.BeanUtils;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.elasticsearch.core.ElasticsearchOperations;
import org.springframework.data.elasticsearch.core.SearchHits;
import org.springframework.data.elasticsearch.core.mapping.IndexCoordinates;
import org.springframework.data.elasticsearch.core.query.*;
import org.springframework.data.elasticsearch.core.query.highlight.Highlight;
import org.springframework.data.elasticsearch.core.query.highlight.HighlightField;
import org.springframework.data.elasticsearch.core.query.highlight.HighlightParameters;

import javax.annotation.Resource;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.Reader;
import java.net.URL;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@SpringBootTest
class TikaTests {

    @Resource
    private EmployeeElasticController employeeElasticController;
    @Resource
    private DocsRepository docsRepository;
    @Resource
    private ElasticsearchOperations elasticsearchOperations;
    @Resource
    private DocsController docsController;
    @Test
    @SneakyThrows
    public  void run2(){
        try {
//            BufferedInputStream in = FileUtil.getInputStream("/Users/wangrui/Downloads/电力电缆头.txt");
//            InputStream resourceAsStream = TikaTests.class.getResourceAsStream("/Users/wangrui/Downloads/电力电缆头.txt");
//            String s1 = new Tika().parseToString(in);
//            System.out.println(s1);
            URL url = new URL("https://platomixtest.oss-cn-beijing.aliyuncs.com/platomixtest/platomixtest.txt?Expires=1695111153&OSSAccessKeyId=TMP.3KgBgUFnL9aMuUY62WrAJLmy7HRTtdbnYi2V5C6VpY1wDHTnos7HhJoEhjcodpcvg25QfFryt328U9QtJ3zAooEe1hnPo5&Signature=qW0aE9GRQdL5eelHUJZ%2FHdPAf8o%3D&response-content-type=text%2Fplain%3Bcharset%3Dutf-8%3B");

            System.out.println(            new Tika().parseToString(url));
            String s = new Tika().parseToString(new File("/Users/wangrui/Downloads/爱小家顾大家+国家电投筑就抗疫“后盾”——国家电投抗疫期间关爱员工家属侧记.pdf"));
//            System.out.println(s);


        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    @Test
    @SneakyThrows
    public  void run(){
        try {
            File file = new File("/Users/wangrui/Downloads/电力储能.xlsx");
            Tika tika = new Tika();
            String fileType = tika.detect(file);

            Reader parse = tika.parse(file);
            String s = tika.parseToString(file);
            System.out.println(s);

            System.out.println(fileType);
            if (fileType != null && fileType.contains("/")) {
                fileType = fileType.substring(fileType.indexOf("/") +1);
            }
            System.out.println(fileType);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
